-- to do 

--win check   --DONE
--remaining mine counter   ---DONE
--show all mines when hit one   ---DONE
--menu background  --- DONE
--reset button   ---DONE
--nicer buttons   -DONE

--open multiple fields when empty field is hit    -- idea
--end game when a mine was hit (not really necessary)  -idea
--time counter/highscores
--sounds 
--make the number of mines constant
--doubleclick a number: open surrounding fields

-- by madG - 2010
--http://www.anythingbutipod.com/forum/forumdisplay.php?f=223
--Version beta 0.6

width = screen.width()
height = screen.height()

clred = color.new(255,0,0)
clgreen = color.new(0,255,0)
clblue = color.new(0,0,255)
clgrey = color.new(55,55,55)
clwhite = color.new(255,255,255)
clblack = color.new(0,0,0)

-- loads images 
one = image.load("1.png")
two = image.load("2.png")
three = image.load("3.png")
four = image.load("4.png")
five = image.load("5.png")
six = image.load("6.png")
seven = image.load("7.png")
eight = image.load("8.png")
minered = image.load("fail.png")
flag = image.load("flag.png")
flag2 = image.load("flag2.png")
closed = image.load("closed.png")	
empty = image.load("empty.png")
mine = image.load("mine.png")
covered = image.load("coveredfield.png")
buttongrey = image.load("buttongrey.png")
buttongreen = image.load("buttongreen.png")
buttonyellow = image.load("buttonyellow.png")
buttonred = image.load("buttonred.png")
background = image.load("background.png")
smileywon = image.load("smileywon.png")
smiley = image.load("smiley.png")
smileyo = image.load("smileyo.png")
smileydead = image.load("smileydead.png")


--screen.fillrect(0,0,width,height,clblack)
background:draw(0,0)
buttongreen:draw(150,60)
buttonyellow:draw(150,105)
buttonred:draw(150,150)
text.color(clblack)
text.size(10)
screen.fillrect(0,220,65,20,clwhite)
--Version
text.draw(10,225,"beta 0.6")
screen.fillrect(330,220,70,20,clwhite)
text.draw(340,225,"by madG")
text.size(20)
text.draw(0,65,"few","center")
text.draw(0,110,"some","center")
text.draw(0,155,"lots","center")


screen.update()

-------------------------------------------------------------------------


function levelmenu()
	
	if y >= 60 and y <= 90 then
	minecount = 10
	game = true
	initialize()
	elseif y >= 105 and y <= 135 then
	minecount = 17
	game = true
	initialize()
	elseif y >= 150 and y <= 180 then
	minecount = 25
	game = true
	initialize()
	else 
	minecount = 1
	game = false
	end
end

function initialize()		--initializes game

mtmines = {}   -- generates minefield matrix
	for i = 1,11,1 do
      mtmines[i] ={}
	  	for j = 1,8,1 do
        mtmines[i][j] = 0
      	end
    end 

mtflag = {}   -- generates flag matrix
	for i = 1,11,1 do
      mtflag[i] ={}
	  	for j = 1,8,1 do
        mtflag[i][j] = 0
      	end
    end 	
	
mtopen = {}   -- generates open matrix
	for i = 1,11,1 do
      mtopen[i] ={}
	  	for j = 1,8,1 do
        mtopen[i][j] = 0
      	end
    end 	
	
randommines() -- works fine.
screen.fillrect(0,0,width,height,clblack)
covered:draw(0,0)
flag:draw(350,105)
marker = false
mine:draw(350,20)
screen.drawrect(340, 15, 388, 90, clwhite)
smiley:draw(350,200)



remaining()

--debug2()    --shows position of mines
end
	
function randommines() --applies random mines to the fields  --works fine but fills in double mines quite often
	for c = 1, minecount,1 do									-- which is no problem but reduces number of mines
		i = math.random(1,11)
		j = math.random(1,8)

		if mtmines[i][j] == 0 then
		mtmines[i][j] = 1
		end
	end
end

function output()    -- checks what is pressed and discoveres the field    
	
	if x >= 340 and x <= 390 and y <= 135 and y >= 105 then   --marks if marker is marked :)
	
		if marker == false then
		marker = true   --change icon of marker needed
		flag2:draw(350,105)
		elseif marker == true then
		marker = false
		flag:draw(350,105)
		end
	
	end
	
	mapx = (x+30)/30
	mapy = (y+30)/30
	fmapx = math.floor(mapx)
	fmapy = math.floor(mapy)
	
		function openormark()
		
			local numbermines = 0
		
			
			
			function minecheck()						--checks the number of surrounding mines and opens the corresponding number
				
								
				
				function open()
					mtopen[fmapx][fmapy] = 1
				
					if mtmines[fmapx][fmapy] == 1 then
					lost()  
					else
								
						if fmapx > 1 and fmapy > 1 then
							if mtmines[(fmapx-1)][(fmapy-1)] == 1 then 
							numbermines = numbermines + 1
							end
						end
						
						if fmapy > 1 then
							if mtmines[(fmapx)][(fmapy-1)] == 1 then  
							numbermines = numbermines + 1
							end
						end
						
						if fmapx < 11 and fmapy > 1 then
							if mtmines[(fmapx+1)][(fmapy-1)] == 1 then 
							numbermines = numbermines + 1
							end
						end
						
						if fmapx > 1 then
							if mtmines[(fmapx-1)][(fmapy)] == 1 then 
							numbermines = numbermines + 1
							end
						end
								
						if fmapx < 11 then
							if mtmines[(fmapx+1)][(fmapy)] == 1 then 
							numbermines = numbermines + 1
							end
						end
						
						if fmapx > 1 and fmapy < 8 then
							if mtmines[(fmapx-1)][(fmapy+1)] == 1 then 
							numbermines = numbermines + 1
							end
						end
							
						if fmapy < 8 then
							if mtmines[(fmapx)][(fmapy+1)] == 1 then 
							numbermines = numbermines + 1
							end
						end
						
						if fmapx < 11 and fmapy < 8 then
						
							if mtmines[(fmapx+1)][(fmapy+1)] == 1 then 
							numbermines = numbermines + 1
							end
						end
						
									
							
							if numbermines == 0 then 
							empty:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 1 then 
							one:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 2 then 
							two:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 3 then 
							three:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 4 then 
							four:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 5 then 
							five:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 6 then 
							six:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 7 then 
							seven:draw((fmapx-1)*30,(fmapy-1)*30)
							end
							if numbermines == 8 then 
							eight:draw((fmapx-1)*30,(fmapy-1)*30)
							end
					end
										
					
					function wincheck()
					sumopen = 0
					for i = 1,11,1 do			--counts opened fields
						for j = 1,8,1 do
							if mtopen[i][j] == 1 then 
							sumopen = sumopen + 1
							end				
						end
					end
					
					realmines = 0
					for i = 1,11,1 do
						for j = 1,8,1 do
							if mtmines[i][j] == 1 then 
							realmines = realmines + 1
							end				
						end
					end
					
					if sumopen + realmines == 88 then
					won()
					end					
					end			
					
					
				end
			
				if mtflag[fmapx][fmapy] == 0 then
				open()
				wincheck()
				end
			
			end
							
				if marker == true then  --marks or unmarks
					if mtopen[fmapx][fmapy] == 0 then					
						if mtflag[fmapx][fmapy] == 0 then	
						flag:draw((fmapx-1)*30,(fmapy-1)*30)
						mtflag[fmapx][fmapy] = 1
						else 
						closed:draw((fmapx-1)*30,(fmapy-1)*30)
						mtflag[fmapx][fmapy] = 0
						end
					end
				else 
				minecheck()
				end
		
		
		end
	
	if fmapx < 12 then
	openormark()
	end
	
	
mapx = 0
mapy = 0
remaining()
screen.update()

	
end

function remaining()  --shows number of remaining mines
realmines = 0	
flags = 0
remainingmines = 0
	for i = 1,11,1 do
		for j = 1,8,1 do
			if mtmines[i][j] == 1 then 
			realmines = realmines + 1
			end				
		end
	end
		
	for i = 1,11,1 do
		for j = 1,8,1 do
			if mtflag[i][j] == 1 then 
			flags = flags + 1
			end				
		end
	end
	
remainingmines = realmines - flags
screen.fillrect(355,65,30,20,clblack)
text.color(clwhite)
text.size(20)
text.draw(330,65,remainingmines,"center")
end

function lost() -- shows all other mines

	for i = 1, 11, 1 do 
		for j = 1, 8, 1 do
			if mtmines[i][j] == 1 then 
			mine:draw(((i-1)*30),((j-1)*30))
			end
		end
	end	
minered:draw((fmapx-1)*30,(fmapy-1)*30)
smileydead:draw(350,200)
screen.update()
os.sleep(200)
end

function won() 
smileywon:draw(350,200)
end

function debug1() -- shows map coordinates and number of surrounding mines after opening a field
		text.color(clwhite)
		text.size(20)
		screen.fillrect(380,0,30,240,clblack)
		text.draw(380,200,numbermines)
				
		text.draw(380,20,fmapx)
		text.draw(380,60,fmapy)
end

function debug2()  --shows position of mines
	
	for i = 1, 11, 1 do 
		for j = 1, 8, 1 do
			if mtmines[i][j] == 1 then 
			mine:draw(((i-1)*30),((j-1)*30))
			else
			empty:draw(((i-1)*30),((j-1)*30))
			end
		end
	end	

end


---game loop 
while 1 do --returns x,y coordinates of touchscreen
	if (control.read()==1) then
			if (control.isTouch() == 1) and (touch.click() == 1) then
				
				if game == true then
				x, y = touch.pos()
					if x > 350 and y > 200 then
					initialize()
					end
				
				output()
				--debug1()
				
				else 				
				x, y = touch.pos()
				levelmenu()
				screen.update()				
				end
				
					
			elseif (control.isButton()==1) and (button.click() == 1) then   -- Error
												
			break
				
			end
	else
	os.sleep(10)
	end
end


